MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sc::IntegralV3 Class Reference

IntegralV3 computes integrals between Gaussian basis functions. More...

`#include <intv3.h>`

Inheritance diagram for sc::IntegralV3:
[legend]
Collaboration diagram for sc::IntegralV3:
[legend]

## Public Member Functions
| IntegralV3 (const Ref< GaussianBasisSet > &b1=0, const Ref< GaussianBasisSet > &b2=0, const Ref< GaussianBasisSet > &b3=0, const Ref< GaussianBasisSet > &b4=0)
| IntegralV3 (StateIn &)
| IntegralV3 (const Ref< KeyVal > &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
Integral * | clone ()
| Clones the given Integral factory. The new factory may need to have set_basis and set_storage to be called on it.
CartesianIter * | new_cartesian_iter (int)
| Return a CartesianIter object. More...
RedundantCartesianIter * | new_redundant_cartesian_iter (int)
| Return a RedundantCartesianIter object. More...
RedundantCartesianSubIter * | new_redundant_cartesian_sub_iter (int)
| Return a RedundantCartesianSubIter object. More...
SphericalTransformIter * | new_spherical_transform_iter (int l, int inv=0, int subl=-1)
| Return a SphericalTransformIter object. More...
const SphericalTransform * | spherical_transform (int l, int inv=0, int subl=-1)
| Return a SphericalTransform object. More...
Ref< OneBodyInt > | overlap ()
| Return a OneBodyInt that computes the overlap.
Ref< OneBodyInt > | kinetic ()
| Return a OneBodyInt that computes the kinetic energy.
Ref< OneBodyInt > | point_charge (const Ref< PointChargeData > &=0)
| Return a OneBodyInt that computes the integrals for interactions with point charges. More...
Ref< OneBodyOneCenterInt > | point_charge1 (const Ref< PointChargeData > &)
| Return a OneBodyInt that computes the integrals for interactions with point charges. More...
Ref< OneBodyInt > | nuclear ()
| Return a OneBodyInt that computes the nuclear repulsion integrals. More...
Ref< OneBodyInt > | hcore ()
| Return a OneBodyInt that computes the core Hamiltonian integrals.
Ref< OneBodyInt > | efield_dot_vector (const Ref< EfieldDotVectorData > &=0)
| Return a OneBodyInt that computes the electric field integrals dotted with a given vector. More...
Ref< OneBodyInt > | dipole (const Ref< DipoleData > &=0)
| Return a OneBodyInt that computes electric dipole moment integrals. More...
Ref< OneBodyInt > | quadrupole (const Ref< DipoleData > &=0)
| Return a OneBodyInt that computes electric quadrupole moment integrals. More...
Ref< OneBodyDerivInt > | overlap_deriv ()
| Return a OneBodyDerivInt that computes overlap derivatives.
Ref< OneBodyDerivInt > | kinetic_deriv ()
| Return a OneBodyDerivInt that computes kinetic energy derivatives.
Ref< OneBodyDerivInt > | nuclear_deriv ()
| Return a OneBodyDerivInt that computes nuclear repulsion derivatives.
Ref< OneBodyDerivInt > | hcore_deriv ()
| Return a OneBodyDerivInt that computes core Hamiltonian derivatives.
Ref< TwoBodyInt > | electron_repulsion ()
| Return a TwoBodyInt that computes electron repulsion integrals.
Ref< TwoBodyTwoCenterInt > | electron_repulsion2 ()
| Return a TwoBodyTwoCenterInt that computes electron repulsion integrals. More...
Ref< TwoBodyThreeCenterInt > | electron_repulsion3 ()
| Return a TwoBodyThreeCenterInt that computes electron repulsion integrals. More...
Ref< TwoBodyDerivInt > | electron_repulsion_deriv ()
| Return a TwoBodyDerivInt that computes electron repulsion derivatives.
void | set_basis (const Ref< GaussianBasisSet > &b1, const Ref< GaussianBasisSet > &b2=0, const Ref< GaussianBasisSet > &b3=0, const Ref< GaussianBasisSet > &b4=0)
| Set the basis set for each center.
Public Member Functions inherited from sc::Integral
| Integral (StateIn &)
| Restore the Integral object from the given StateIn object.
| Integral (const Ref< KeyVal > &)
| Construct the Integral object from the given KeyVal object.
virtual int | equiv (const Ref< Integral > &)
| Returns nonzero if this and the given Integral object have the same integral ordering, normalization conventions, etc. More...
void | set_storage (size_t i)
| Sets the total amount of storage, in bytes, that is available.
size_t | storage_used ()
| Returns how much storage has been used.
size_t | storage_unused ()
| Returns how much storage was not needed.
virtual size_t | storage_required_eri (const Ref< GaussianBasisSet > &b1, const Ref< GaussianBasisSet > &b2=0, const Ref< GaussianBasisSet > &b3=0, const Ref< GaussianBasisSet > &b4=0)
| Returns how much storage will be needed to initialize a two-body integrals evaluator for electron repulsion integrals. More...
virtual size_t | storage_required_grt (const Ref< GaussianBasisSet > &b1, const Ref< GaussianBasisSet > &b2=0, const Ref< GaussianBasisSet > &b3=0, const Ref< GaussianBasisSet > &b4=0)
| Returns how much storage will be needed to initialize a two-body integrals evaluator for linear R12 integrals. More...
virtual size_t | storage_required_eri_deriv (const Ref< GaussianBasisSet > &b1, const Ref< GaussianBasisSet > &b2=0, const Ref< GaussianBasisSet > &b3=0, const Ref< GaussianBasisSet > &b4=0)
| Returns how much storage will be needed to initialize a two-body integrals evaluator for derivative electron repulsion integrals. More...
void | adjust_storage (ptrdiff_t s)
| The specific integral classes use this to tell Integral how much memory they are using/freeing. More...
Ref< PetiteList > | petite_list ()
| Return the PetiteList object.
Ref< PetiteList > | petite_list (const Ref< GaussianBasisSet > &)
| Return the PetiteList object for the given basis set.
ShellRotation | shell_rotation (int am, SymmetryOperation &, int pure=0)
| Return the ShellRotation object for a shell of the given angular momentum. More...
virtual Ref < TwoBodyThreeCenterDerivInt > | electron_repulsion3_deriv ()
| Return a TwoBodyThreeCenterInt that computes electron repulsion integrals. More...
virtual Ref < TwoBodyTwoCenterDerivInt > | electron_repulsion2_deriv ()
| Return a TwoBodyTwoCenterInt that computes electron repulsion integrals. More...
virtual Ref< TwoBodyInt > | grt ()
| Return a TwoBodyInt that computes two-electron integrals specific to linear R12 methods. More...
Ref< MessageGrp > | messagegrp ()
| Return the MessageGrp used by the integrals objects.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members
Static Public Member Functions inherited from sc::Integral
static Integral * | initial_integral (int &argc, char **argv)
| Create an integral factory. More...
static void | set_default_integral (const Ref< Integral > &)
| Specifies a new default Integral factory.
static Integral * | get_default_integral ()
| Returns the default Integral factory.
Protected Member Functions inherited from sc::Integral
| Integral (const Ref< GaussianBasisSet > &b1, const Ref< GaussianBasisSet > &b2, const Ref< GaussianBasisSet > &b3, const Ref< GaussianBasisSet > &b4)
| Initialize the Integral object given a GaussianBasisSet for each center. More...
Protected Attributes inherited from sc::Integral
Ref< GaussianBasisSet > | bs1_
Ref< GaussianBasisSet > | bs2_
Ref< GaussianBasisSet > | bs3_
Ref< GaussianBasisSet > | bs4_
size_t | storage_
size_t | storage_used_
Ref< MessageGrp > | grp_

## Detailed Description

IntegralV3 computes integrals between Gaussian basis functions.

## Member Function Documentation

Ref<OneBodyInt> sc::IntegralV3::dipole | ( | const Ref< DipoleData > & | = `0` | ) |
| virtual

Return a OneBodyInt that computes electric dipole moment integrals.

The canonical order of integrals in a set is x, y, z.

Implements sc::Integral.

Ref<OneBodyInt> sc::IntegralV3::efield_dot_vector | ( | const Ref< EfieldDotVectorData > & | = `0` | ) |
| virtual

Return a OneBodyInt that computes the electric field integrals dotted with a given vector.

Implements sc::Integral.

Ref<TwoBodyTwoCenterInt> sc::IntegralV3::electron_repulsion2 | ( |  | ) |
| virtual

Return a TwoBodyTwoCenterInt that computes electron repulsion integrals.

If this is not re-implemented it will throw.

Reimplemented from sc::Integral.

Ref<TwoBodyThreeCenterInt> sc::IntegralV3::electron_repulsion3 | ( |  | ) |
| virtual

Return a TwoBodyThreeCenterInt that computes electron repulsion integrals.

If this is not re-implemented it will throw.

Reimplemented from sc::Integral.

CartesianIter* sc::IntegralV3::new_cartesian_iter | ( | int |  | ) |
| virtual

Return a CartesianIter object.

The caller is responsible for freeing the object.

Implements sc::Integral.

RedundantCartesianIter* sc::IntegralV3::new_redundant_cartesian_iter | ( | int |  | ) |
| virtual

Return a RedundantCartesianIter object.

The caller is responsible for freeing the object.

Implements sc::Integral.

RedundantCartesianSubIter* sc::IntegralV3::new_redundant_cartesian_sub_iter | ( | int |  | ) |
| virtual

Return a RedundantCartesianSubIter object.

The caller is responsible for freeing the object.

Implements sc::Integral.

SphericalTransformIter* sc::IntegralV3::new_spherical_transform_iter | ( | int | l,
|  | int | inv = `0`,
|  | int | subl = `-1`
| ) |  |
| virtual

Return a SphericalTransformIter object.

The caller is responsible for freeing the object.

Implements sc::Integral.

Ref<OneBodyInt> sc::IntegralV3::nuclear | ( |  | ) |
| virtual

Return a OneBodyInt that computes the nuclear repulsion integrals.

Charges from the atoms on center one are used. If center two is not identical to center one, then the charges on center two are included as well.

Implements sc::Integral.

Ref<OneBodyInt> sc::IntegralV3::point_charge | ( | const Ref< PointChargeData > & | = `0` | ) |
| virtual

Return a OneBodyInt that computes the integrals for interactions with point charges.

Implements sc::Integral.

Ref<OneBodyOneCenterInt> sc::IntegralV3::point_charge1 | ( | const Ref< PointChargeData > & |  | ) |
| virtual

Return a OneBodyInt that computes the integrals for interactions with point charges.

Reimplemented from sc::Integral.

Ref<OneBodyInt> sc::IntegralV3::quadrupole | ( | const Ref< DipoleData > & | = `0` | ) |
| virtual

Return a OneBodyInt that computes electric quadrupole moment integrals.

The canonical order of integrals in a set is x^2, xy, xz, y^2, yz, z^2.

Implements sc::Integral.

void sc::IntegralV3::save_data_state | ( | StateOut & |  | ) |
| virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::Integral.

const SphericalTransform* sc::IntegralV3::spherical_transform | ( | int | l,
|  | int | inv = `0`,
|  | int | subl = `-1`
| ) |  |
| virtual

Return a SphericalTransform object.

The pointer is only valid while this Integral object is valid.

Implements sc::Integral.

The documentation for this class was generated from the following file:

- intv3.h